'use strict';

var storagesApp = angular.module("storagesApp", [
	"commonApp"
]);

storagesApp.controller("StoragesCtrl", 
	["$scope", "$http", 
	function($scope, $http) {
 		
	$scope.text = null;
	$scope.textUrl = null;
	$scope.fileUrl = null;
	
	$scope.uploadText = function() {
		$scope.textUrl = null;
		
		$http({
		    method: 'POST',
		    url: "../../storage",
		    data:$scope.text,
		    headers: { 'Content-Type': 'text/plain' }
		})
		.then(function(response) {
			$scope.textUrl = response.data;
			$('textAlert').show();
		});
	};
	
	$scope.uploadFile = function() {
		$scope.fileUrl = null;
		
		$('#uploadFileForm').ajaxSubmit({
			url: "../../storage",
			success: function(data, statusText, xhr) {
				$scope.fileUrl = $scope.getContentLocation(xhr);
				$scope.$apply();
			},
			error: function (xhr, ajaxOptions, thrownError) {
		        alert(thrownError);
		    }
		}); 
	};
	
	$scope.getContentLocation = function(xhr) {
		
		// Content-Location in header
		var location = xhr.getResponseHeader("Content-Location");
		
		// Content-Location in response body (the header might not be seen using older browsers)
		if (! location) {
			location = xhr.responseText;
			
			// there might be surrounding <pre> </pre>
			if (location && location.length > 11 && location.slice(0, 5).toLowerCase() == "<pre>") {
				location = location.slice(5, location.length - 6);
			}
		}
		
		return location;
	};
}]);