'use strict';

var structuresApp = angular.module("structuresApp", [
	"commonApp"
]);

structuresApp.controller("StructuresCtrl", 
	["$scope", "$http", 
	function($scope, $http) {
		
	$scope.loading = true;
	$scope.error = null;
	$scope.structures = [];
	
	$http.get("../../internal/extensionPoint/com.sodius.mdw.server.structureProvider")
		.then(function(res) {
			$scope.loading = false;
			
			// retain here only the structures with a test page
			angular.forEach(res.data.extensions, function(structure) {
				if (structure.elements) {
					var i = 0;
					for (i = 0; i < structure.elements.length; i++) {
						var element = structure.elements[i];
						if (element.element == "testPage" && element.url) {
							structure.launchPageUrl = element.url;
							$scope.structures.push(structure);
							break;
						}
					}
				}
			});
		}, function(error) {
			$scope.loading = false;
			$scope.error = error.data;
		});
	
	$scope.getHref = function(structure) {
		return "../.." + structure.launchPageUrl;
	};
}]);
