bool moduleWasInEditMode = false;
Object objectForConversion = null;

void sodius_initializeConversion(Item self) {
	if (null self) {
		return;
	}
	
	Module m = module(self);
	if (null m) {
		return;
	}
	
	moduleWasInEditMode = isEdit(m) || isShare(m);
}

void sodius_discardConversionChanges(bool isCreateMode) {
	if (null openedModule) {
		sodius_discardAndClose();
		return;
	}
	
	Item i = item(fullName(openedModule));
	
	// module was created for the conversion -> delete it now
	if (isCreateMode) {
		sodius_discardAndClose();
		if (sodius_isTerminated()) return;
		sodius_deleteItem(i);
		if (sodius_isTerminated()) return;
		sodius_purgeItem(i);
	}
	else {
		
		// module was already in edit mode -> just delete the temporary object
		if (moduleWasInEditMode) {
			hardDelete(objectForConversion);
			sodius_writeOutput();
			sodius_finalize();
		}
		
		// module was in edit mode -> discard all changes and close
		else {
			sodius_discardAndClose();
		}
	}
}

Object sodius_createTemporaryObject() {
	if (isShare(openedModule)) {
		Object o;
		for o in all openedModule do {
			string message = lock(o);
			if (null message) {
				return create(below(o));
			}
		}
		sodius_setError("Cannot create a temporary object in module in share mode: no container object can be locked");
		return null;
	}
	else {
		return create(openedModule);
	}
}

void sodius_convertBinaryToOLE(string binaryFile, string oleFile, bool insertAsIcon) {
	
	// ensure conversion object is ready
	if (null objectForConversion) {
		objectForConversion = sodius_createTemporaryObject();
		if (null objectForConversion) {
			return;
		}
	}
	else {
		objectForConversion."Object Text" = "";
	}
	
	// convert
	if (! oleInsert(objectForConversion, binaryFile, insertAsIcon)) {
		sodius_setError("Cannot insert an OLE in object: " objectForConversion."Absolute Number" "");
	}
	else {
		// output conversion result into the target file
		Buffer buffer = create(2048);
		buffer = richTextWithOle(objectForConversion."Object Text");
		Stream file = write(oleFile, CP_UTF8);
		file << buffer;
		delete(buffer);
		close(file);
	}
}
