Discussion lud = null;

Discussion sodius_registerCreatedDiscussion(Discussion d, int index) {
	bool result = put(createdDiscussionsSkip, index, d);
	if (result) {
		sodius_setOutput(index, "" index ""); 
		return d;
	}
	else {
		sodius_setError("Cannot register a created discussion: " index "");
		return null;
	}
}

Discussion sodius_getCreatedDiscussion(int index) {
	if (sodius_isTerminated()) {
		return null;
	}
	
	Discussion d = null;
	bool result = find(createdDiscussionsSkip, index, d);
	if (result) {
		lud = d;
		return d;
	}
	else {
		sodius_setError("Cannot find a created discussion: " index "");
		return null;
	}
}

Discussion sodius_findModuleDiscussion(string s, string creator) {
	if (sodius_isTerminated()) {
		return null;
	}
	
	Discussion d = null;
	for d in openedModule do {
		if (s == d.summary) {
			
			if (null creator || creator == d.createdByName) {
				lud = d;
				return d;
			}
		}
	}

	sodius_setError("Cannot find a module discussion" (null creator ? "" : " created by " creator "") " with the following summary: " s);
	return null;
}

Discussion sodius_findObjectDiscussion(Object o, string s, string creator) {
	if (null o) {
		return null;
	}
	
	Discussion d = null;
	for d in o do {
		if (s == d.summary) {
			
			if (null creator || creator == d.createdByName) {
				lud = d;
				return d;
			}
		}
	}

	sodius_setError("Cannot find a discussion on Object " o."Absolute Number" (null creator ? "" : " created by " creator "") " with the following summary: " s);
	return null;
}

Discussion sodius_createModuleDiscussion(int index, string s, string t) {
	if (sodius_isTerminated()) {
		return null;
	}
	
	Discussion d;
	string message = create(openedModule, t, s, d)
    if (! null message) {
    	sodius_setError("Cannot create a module discussion: " message);
		return null;
    }
	else {
		return sodius_registerCreatedDiscussion(d, index);
	}
}

Discussion sodius_createObjectDiscussion(int index, Object o, string s, string t) {
	if (null o) {
		return;
	}
	
	Discussion d;
	string message = create(o, t, s, d)
    if (! null message) {
    	sodius_setError("Cannot create a discussion for Object " o."Absolute Number" ": " message);
		return null;
    }
	else {
		return sodius_registerCreatedDiscussion(d, index);
	}
}

void sodius_createModuleComment(Discussion d, string t) {
	if (null d) {
		return;
	}
	
	Comment c;
	string message = addComment(d, openedModule, t, c);
    if (! null message) {
    	sodius_setError("Cannot create a module comment: " message);
		return;
    }
}

void sodius_createObjectComment(Discussion d, Object o, string t) {
	if (null d) {
		return;
	}
	if (null o) {
		return;
	}
	
	Comment c;
	string message = addComment(d, o, t, c);
    if (! null message) {
    	sodius_setError("Cannot create a comment for Object " o."Absolute Number" ": " message);
		return;
    }
}

void sodius_closeModuleDiscussion(Discussion d, string t) {
	if (null d) {
		return;
	}
	
	Comment c;
	string message = closeDiscussion(d, openedModule, t, c);
    if (! null message) {
    	sodius_setError("Cannot close a module discussion: " message);
		return;
    }
}

void sodius_closeObjectDiscussion(Discussion d, Object o, string t) {
	if (null d) {
		return;
	}
	if (null o) {
		return;
	}
	
	Comment c;
	string message = closeDiscussion(d, o, t, c);
    if (! null message) {
    	sodius_setError("Cannot close a discussion for Object " o."Absolute Number" ": " message);
		return;
    }
}

void sodius_reopenModuleDiscussion(Discussion d, string t) {
	if (null d) {
		return;
	}
	
	Comment c;
	string message = reopenDiscussion(d, openedModule, t, c);
    if (! null message) {
    	sodius_setError("Cannot reopen a module discussion: " message);
		return;
    }
}

void sodius_reopenObjectDiscussion(Discussion d, Object o, string t) {
	if (null d) {
		return;
	}
	if (null o) {
		return;
	}
	
	Comment c;
	string message = reopenDiscussion(d, o, t, c);
    if (! null message) {
    	sodius_setError("Cannot reopen a discussion for Object " o."Absolute Number" ": " message);
		return;
    }
}

void sodius_deleteModuleDiscussion(Discussion d, string unused) {
	if (null d) {
		return;
	}
	
	string message = deleteDiscussion(d, openedModule);
    if (! null message) {
    	sodius_setError("Cannot delete a module discussion: " message);
		return;
    }
}

void sodius_deleteObjectDiscussion(Discussion d, Object o, string unused) {
	if (null d) {
		return;
	}
	if (null o) {
		return;
	}
	
	string message = deleteDiscussion(d, o);
    if (! null message) {
    	sodius_setError("Cannot delete a discussion for Object " o."Absolute Number" ": " message);
		return;
    }
}
