void closeCurrentModule(string fullName) {
    Item i = item(fullName);
    if (! null i) {
        string itemType = type(i);
        if (itemType == "Formal" || itemType == "Link") {
            Module m = module(i)
            if (! null m) {
                if (! isVisible(m)) {
                    close(m);
                }
            }
        }
    }
}

void closeBaselineModule(string fullName) {
    string baselineID = null;
    if (find(BASELINE_IDS, fullName, baselineID)) {
        Baseline baselineInfo = parseBaseline(baselineID);
        if (! null baselineInfo) {
            
            ModName_ modName = module(fullName);
            ModuleVersion version = moduleVersion(modName, baselineInfo);
            Module m = data(version);
            
            if (! null m && ! isVisible(m)) {
                close(m);
            }
        }
    }
}

void closeModule(string fullName) {
    closeCurrentModule(fullName);
    closeBaselineModule(fullName);
}

