void writeComment(Comment self) {
    if (null self) 
        return;

    writeXMLStartTag(START_TAG_COMMENT);
    Date d;
    writeXMLAttributeString(ATTR_DISCUSSIONELEMENT_CREATEDBY, self.createdByName);
    d = self.createdOn
    writeXMLAttributeDate(ATTR_DISCUSSIONELEMENT_CREATEDON, d);
    writeXMLAttributeString(ATTR_DISCUSSIONELEMENT_STATUS, "" self.status "");
    writeXMLAttributeString(ATTR_COMMENT_TEXT, self.text);
    writeXMLAttributeBool(ATTR_COMMENT_CHANGEDSTATUS, self.changedStatus);
    writeXMLEndTag();
}

void writeDiscussionComments(Discussion self) {
    if (null self) 
        return;

    writeXMLStartTag(START_TAG_DISCUSSION_COMMENTS);
    Comment c;
    for c in self do {
        writeComment(c);
    }
    writeXMLEndTag();
}

void writeDiscussion(Discussion self) {
    if (null self) 
        return;

    writeXMLStartTag(START_TAG_DISCUSSION);
    Date d;
    writeXMLAttributeString(ATTR_DISCUSSIONELEMENT_CREATEDBY, self.createdByName);
    d = self.createdOn;
    writeXMLAttributeDate(ATTR_DISCUSSIONELEMENT_CREATEDON, d);
    writeXMLAttributeString(ATTR_DISCUSSION_LASTMODIFIEDBY, self.lastModifiedByName);
    d = self.lastModifiedOn;
    writeXMLAttributeDate(ATTR_DISCUSSION_LASTMODIFIEDON, d);
    writeXMLAttributeString(ATTR_DISCUSSIONELEMENT_STATUS, "" self.status "");
    writeXMLAttributeString(ATTR_DISCUSSION_SUMMARY, self.summary);
    
    writeDiscussionComments(self);
    
    writeXMLEndTag();
}

void writeFormalModuleDiscussionsEmpty(Module self) {
    if (null self) 
        return;
    if (OPTION_IGNORE_DISCUSSIONS)
        return;
    if (! isEmptyFeatureRequested(FEATURE_DISCUSSIONCONTAINER_DISCUSSIONS))
        return;
    
    getDiscussions(self);
    Discussion d;
    for d in self do {
        return;
    }
    
    writeXMLStartTag(START_TAG_DISCUSSIONCONTAINER_DISCUSSIONS);
    writeXMLEndTag();
}

void writeFormalModuleDiscussions(Module self) {
    if (null self) 
        return;
    if (OPTION_IGNORE_DISCUSSIONS)
        return;
    if (! isFeatureRequested(FEATURE_DISCUSSIONCONTAINER_DISCUSSIONS)) {
        writeFormalModuleDiscussionsEmpty(self);
        return;
    }
    
    writeXMLStartTag(START_TAG_DISCUSSIONCONTAINER_DISCUSSIONS);
    getDiscussions(self);
    Discussion d;
    for d in self do {
	    writeDiscussion(d);
    }
    writeXMLEndTag();
}

void writeObjectDiscussionsEmpty(Object self) {
    if (null self) 
        return;
    if (OPTION_IGNORE_DISCUSSIONS)
        return;
    if (! isEmptyFeatureRequested(FEATURE_DISCUSSIONCONTAINER_DISCUSSIONS))
        return;
    
    getDiscussions(self);
    Discussion d;
    for d in self do {
        return;
    }
    
    writeXMLStartTag(START_TAG_DISCUSSIONCONTAINER_DISCUSSIONS);
    writeXMLEndTag();
}

void writeObjectDiscussions(Object self) {
    if (null self) 
        return;
    if (OPTION_IGNORE_DISCUSSIONS)
        return;
    if (! isFeatureRequested(FEATURE_DISCUSSIONCONTAINER_DISCUSSIONS)) {
        writeObjectDiscussionsEmpty(self);
        return;
    }
    
    writeXMLStartTag(START_TAG_DISCUSSIONCONTAINER_DISCUSSIONS);
    getDiscussions(self);
    Discussion d;
    for d in self do {
        writeDiscussion(d);
    }
    writeXMLEndTag();
}
