Buffer buffer = create

void closeFile() {
    if (length buffer != 0) {
        Stream file = write(outputFilename, DOORS_CODEPAGE)
        file << stringOf buffer
        close(file)
    }
    delete buffer
}
    
void writeFolderHierarchy(Folder self) {
    if (null self)
        return;
        
    Folder f = getParentFolder(self);
    if (! null f)
        writeFolderHierarchy(f);
    
    // don't print id of database root    
    if (! null f)
        buffer += getIDFolder(self) "\n";
}

void writeItemHierarchy(Item self) {
    if (null self)
        return;
        
    Folder f = getParentFolder(self);
    if (! null f)
        writeFolderHierarchy(f);
        
    buffer += getIDItem(self) "\n";
}

void writeModuleHierarchy(Module self) {
    if (null self)
        return;
        
    Folder f = getParentFolder(self);
    if (! null f)
        writeFolderHierarchy(f);
        
    buffer += getIDModule(self) "\n";
}

bool isIgnorableObject(Object self) {
    if (! OPTION_IGNORE_TABLE) {
        return false;
    }
    else {
        return table(self) || row(self);
    }
}

void writeObjectHierarchy(Object self) {
    if (null self)
        return;
        
    Object p = parent(self)
    if (null p) {
        writeModuleHierarchy(module(self));
    }
    else {
        writeObjectHierarchy(p);
    }
    
    if (! isIgnorableObject(self)) {
        buffer += getIDObject(self) "\n";
    }
}

void writeIDHierarchy(string id) {
    Item i;
    int objectAbsno = -1;
    if (decodeID(id, i, objectAbsno)) {
        string itemType = type(i);
        
        // object?
        if (objectAbsno >= 0 && (itemType == "Formal" || itemType == "Link")) {
            Object o = getObject(objectAbsno, i)
            if (! null o) {
                writeObjectHierarchy(o);
                closeFile();
            } 
        }
        
        // item
        else {
            writeItemHierarchy(i);
            closeFile();
        }
        
    }
} 

