package com.sodius.mdw.samples.cpp;

import java.util.Iterator;
import java.util.List;

import com.sodius.mdw.core.model.DefaultMDWList;
import com.sodius.mdw.core.model.MDWList;
import com.sodius.mdw.metamodel.uml21.Classifier;
import com.sodius.mdw.metamodel.uml21.scripts.ClassScriptContainer;

public class uml21_Class extends ClassScriptContainer {

	/**
	 * Returns a list of classes (Class instances) referenced in the body of this Class.
	 * The list is sorted alphabetically (using classes qualified name).
	 */
	public List requiredClasses() {
		MDWList classes = new DefaultMDWList();
		for (Iterator i = self.toList("referencedClassifiers").iterator(); i.hasNext(); ) {
			Classifier classifier = (Classifier) i.next();
			
			// avoid duplicates and check namespace
			if (classifier instanceof com.sodius.mdw.metamodel.uml21.Class && 
				!classes.contains(classifier) &&
				!classifier.equals(self))
				
				classes.add(classifier);
		}
		
		// sort classes using their names
		return classes.sort("name");
	}
}
