package com.sodius.mdw.samples.java;

import java.util.Iterator;
import java.util.List;

import com.sodius.mdw.core.model.DefaultMDWList;
import com.sodius.mdw.core.model.MDWList;
import com.sodius.mdw.metamodel.uml21.Classifier;
import com.sodius.mdw.metamodel.uml21.Namespace;
import com.sodius.mdw.metamodel.uml21.scripts.ClassScriptContainer;

public class uml21_Class extends ClassScriptContainer {

	/**
	 * Returns a list of classes (Class instances) referenced in the body of this Class,
	 * that are not part of the receiver's namespace.
	 * These classes should be part of the import declarations in the generated .java file.
	 * The list is sorted alphabetically (using classes qualified name).
	 */
	public List requiredClasses() {
		Namespace selfNamespace = self.getNamespace();
		
		MDWList classes = new DefaultMDWList();
		for (Iterator i = self.toList("referencedClassifiers").iterator(); i.hasNext(); ) {
			Classifier classifier = (Classifier) i.next();
			
			// avoid duplicates and check namespace
			if (classifier instanceof com.sodius.mdw.metamodel.uml21.Class && 
				!classes.contains(classifier) &&
				!(classifier.getNamespace() == null || classifier.getNamespace().equals(selfNamespace)))
				
				classes.add(classifier);
		}
		
		// sort classes using their qualified names
		return classes.sort("qualifiedName");
	}
}
